# Class StorageArchivist<TParams, TEventData>

#### Type Parameters

- #### TParams extends StorageArchivistParams = StorageArchivistParams

- #### TEventData extends ArchivistModuleEventData = ArchivistModuleEventData

#### Hierarchy

- AbstractArchivist<TParams, TEventData>
  - StorageArchivist

- Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:19

#####
Index

### Constructors

constructor

### Properties

_baseModuleQueryAccountPaths
_privateStorage
_queryAccounts
_started
_storage
account
commitArchivist
downResolver
eventData
moduleConfigQueryValidator
params
readArchivist
supportedQueryValidator
upResolver
writeArchivist
configSchema
defaultLogger?

### Accessors

_queryAccountPaths
address
allowAnonymous
config
logger
maxEntries
maxEntrySize
namespace
persistAccount
privateStorage
queries
queryAccountPaths
queryAccounts
storage
storeParentReads
type

### Methods

all
bindHashes
bindHashesInternal
bindQuery
bindQueryInternal
bindQueryResult
clear
clearListeners
commit
delete
discover
emit
emitSerial
get
getFromParents
head
initializeQueryAccounts
insert
listenerCount
loadAccount
moduleAccountQuery
off
offAny
on
onAny
once
parents
query
queryHandler
queryable
resolve
saveAccount
start
started
stop
subscribe
validateConfig
writeToParent
writeToParents
create
factory

## Constructors

### constructor

- new StorageArchivist<TParams, TEventData>(params): StorageArchivist<TParams, TEventData>

- #### Type Parameters

  - #### TParams extends StorageArchivistParams = StorageArchivistParams

  - #### TEventData extends ArchivistModuleEventData<TEventData> = ArchivistModuleEventData

  #### Parameters

  - ##### params: TParams

  #### Returns StorageArchivist<TParams, TEventData>

  Inherited from AbstractArchivist.constructor

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:22

## Properties

### `Protected` `Readonly` _baseModuleQueryAccountPaths

_baseModuleQueryAccountPaths: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", string>

Inherited from AbstractArchivist._baseModuleQueryAccountPaths

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:16

### `Private` _privateStorage

_privateStorage: any

- Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:21

### `Protected` `Readonly` _queryAccounts

_queryAccounts: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", undefined | AccountInstance>

Inherited from AbstractArchivist._queryAccounts

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:17

### `Protected` _started

_started: boolean

Inherited from AbstractArchivist._started

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:18

### `Private` _storage

_storage: any

- Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:22

### `Protected` `Readonly` account

account: AccountInstance

Inherited from AbstractArchivist.account

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:19

### `Protected` commitArchivist

commitArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractArchivist.commitArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:44

### `Readonly` downResolver

downResolver: CompositeModuleResolver

Inherited from AbstractArchivist.downResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:14

### eventData

eventData: TEventData

Inherited from AbstractArchivist.eventData

- Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:4

### `Protected` `Readonly` moduleConfigQueryValidator

moduleConfigQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from AbstractArchivist.moduleConfigQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:20

### `Readonly` params

params: TParams

Inherited from AbstractArchivist.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Protected` readArchivist

readArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractArchivist.readArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:80

### `Protected` `Readonly` supportedQueryValidator

supportedQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from AbstractArchivist.supportedQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:21

### `Readonly` upResolver

upResolver: CompositeModuleResolver

Inherited from AbstractArchivist.upResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:15

### `Protected` writeArchivist

writeArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractArchivist.writeArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:116

### `Static` configSchema

configSchema: "network.xyo.module.config.archivist.storage"

Overrides AbstractArchivist.configSchema

- Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:20

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from AbstractArchivist.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

## Accessors

### `Protected` _queryAccountPaths

- get _queryAccountPaths(): Record<"network.xyo.query.archivist.all" | "network.xyo.query.archivist.clear" | "network.xyo.query.archivist.commit" | "network.xyo.query.archivist.delete" | "network.xyo.query.archivist.get" | "network.xyo.query.archivist.insert", string>

- #### Returns Record<"network.xyo.query.archivist.all" | "network.xyo.query.archivist.clear" | "network.xyo.query.archivist.commit" | "network.xyo.query.archivist.delete" | "network.xyo.query.archivist.get" | "network.xyo.query.archivist.insert", string>

  Inherited from AbstractArchivist._queryAccountPaths

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:16

### address

- get address(): string

- #### Returns string

  Inherited from AbstractArchivist.address

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:23

### allowAnonymous

- get allowAnonymous(): boolean

- #### Returns boolean

  Inherited from AbstractArchivist.allowAnonymous

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:24

### config

- get config(): TParams["config"]

- #### Returns TParams["config"]

  Inherited from AbstractArchivist.config

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:25

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from AbstractArchivist.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### maxEntries

- get maxEntries(): number

- #### Returns number

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:23

### maxEntrySize

- get maxEntrySize(): number

- #### Returns number

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:24

### namespace

- get namespace(): string

- #### Returns string

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:25

### persistAccount

- get persistAccount(): boolean

- #### Returns boolean

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:26

### `Private` privateStorage

- get privateStorage(): any

- #### Returns any

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:29

### queries

- get queries(): string[]

- #### Returns string[]

  Overrides AbstractArchivist.queries

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:27

### queryAccountPaths

- get queryAccountPaths(): Readonly<Record<string, undefined | string>>

- #### Returns Readonly<Record<string, undefined | string>>

  Inherited from AbstractArchivist.queryAccountPaths

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:27

### queryAccounts

- get queryAccounts(): Readonly<Record<string, undefined | AccountInstance>>

- #### Returns Readonly<Record<string, undefined | AccountInstance>>

  Inherited from AbstractArchivist.queryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:28

### `Private` storage

- get storage(): any

- #### Returns any

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:30

### `Protected` storeParentReads

- get storeParentReads(): boolean

- #### Returns boolean

  Inherited from AbstractArchivist.storeParentReads

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:17

### type

- get type(): "local" | "session" | "page"

- #### Returns "local" | "session" | "page"

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:28

## Methods

### all

- all(): PromisableArray<SchemaFields & PayloadFields & {
  schema: string;
  }, never>

- #### Returns PromisableArray<SchemaFields & PayloadFields & {
  schema: string;
  }, never>

  Overrides AbstractArchivist.all

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:31

### `Protected` bindHashes

- bindHashes(hashes, schema, account?): PromiseEx<unknown, AccountInstance>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<unknown, AccountInstance>

  Inherited from AbstractArchivist.bindHashes

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:39

### `Protected` bindHashesInternal

- bindHashesInternal(hashes, schema, account?): Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

  Inherited from AbstractArchivist.bindHashesInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:40

### `Protected` bindQuery

- bindQuery<T>(query, payloads?, account?): PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

  Inherited from AbstractArchivist.bindQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:41

### `Protected` bindQueryInternal

- bindQueryInternal<T>(query, payloads?, account?): Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from AbstractArchivist.bindQueryInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:42

### `Protected` bindQueryResult

- bindQueryResult<T>(query, payloads, additionalWitnesses?): PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` additionalWitnesses: AccountInstance[]

  #### Returns PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

  Inherited from AbstractArchivist.bindQueryResult

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:43

### clear

- clear(): void | Promise<void>

- #### Returns void | Promise<void>

  Overrides AbstractArchivist.clear

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:32

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: keyof TEventData | (keyof TEventData)[]

  #### Returns void

  Inherited from AbstractArchivist.clearListeners

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:7

### commit

- commit(): Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

- #### Returns Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

  Overrides AbstractArchivist.commit

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:33

### delete

- delete(hashes): Promise<boolean[]>

- #### Parameters

  - ##### hashes: string[]

  #### Returns Promise<boolean[]>

  Overrides AbstractArchivist.delete

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:34

### discover

- discover(): Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

  Inherited from AbstractArchivist.discover

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:32

### emit

- emit<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends string | number | symbol = keyof TEventData

  - #### TEventArgs extends EventArgs = TEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Inherited from AbstractArchivist.emit

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:8

### emitSerial

- emitSerial<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends string | number | symbol = keyof TEventData

  - #### TEventArgs extends EventArgs = TEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Inherited from AbstractArchivist.emitSerial

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:9

### get

- get(hashes): Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

- #### Parameters

  - ##### hashes: string[]

  #### Returns Promise<(SchemaFields & PayloadFields & {
  schema: string;
  })[]>

  Overrides AbstractArchivist.get

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:35

### `Protected` getFromParents

- getFromParents(hash): Promise<null | SchemaFields & PayloadFields & {
  schema: string;
  }>

- #### Parameters

  - ##### hash: string

  #### Returns Promise<null | SchemaFields & PayloadFields & {
  schema: string;
  }>

  Inherited from AbstractArchivist.getFromParents

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:24

### head

- head(): Promisable<undefined | SchemaFields & PayloadFields & {
  schema: string;
  }, never>

- #### Returns Promisable<undefined | SchemaFields & PayloadFields & {
  schema: string;
  }, never>

  Inherited from AbstractArchivist.head

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:23

### `Protected` initializeQueryAccounts

- initializeQueryAccounts(): void

- #### Returns void

  Inherited from AbstractArchivist.initializeQueryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:77

### insert

- insert(payloads): Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

- #### Parameters

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

  Overrides AbstractArchivist.insert

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:36

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: keyof TEventData | (keyof TEventData)[]

  #### Returns number

  Inherited from AbstractArchivist.listenerCount

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:10

### `Protected` loadAccount

- loadAccount(account?): AccountInstance

- #### Parameters

  - ##### `Optional` account: AccountInstance

  #### Returns AccountInstance

  Overrides AbstractArchivist.loadAccount

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:38

### moduleAccountQuery

- moduleAccountQuery(): Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

  Inherited from AbstractArchivist.moduleAccountQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:33

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns void

  Inherited from AbstractArchivist.off

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:11

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Inherited from AbstractArchivist.offAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:12

### on

- on<TEventName>(eventNames, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Inherited from AbstractArchivist.on

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:13

### onAny

- onAny(listener): (() => void)

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Inherited from AbstractArchivist.onAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:14

### once

- once<TEventName>(eventName, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends string | number | symbol

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<TEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Inherited from AbstractArchivist.once

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:15

### `Protected` parents

- parents(): Promise<XyoArchivistParentWrappers>

- #### Returns Promise<XyoArchivistParentWrappers>

  Inherited from AbstractArchivist.parents

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:27

### query

- query<T, TConfig>(query, payloads?, queryConfig?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Inherited from AbstractArchivist.query

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:34

### `Protected` queryHandler

- queryHandler<T, TConfig>(query, payloads?, queryConfig?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Inherited from AbstractArchivist.queryHandler

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:28

### queryable

- queryable<T, TConfig>(query, payloads?, queryConfig?): boolean

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns boolean

  Inherited from AbstractArchivist.queryable

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:35

### `Protected` resolve

- resolve<TModule>(filter?): Promise<TModule[]>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Inherited from AbstractArchivist.resolve

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:113

### `Protected` saveAccount

- saveAccount(): void

- #### Returns void

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:39

### start

- start(): Promise<void>

- #### Returns Promise<void>

  Overrides AbstractArchivist.start

  - Defined in modules/packages/archivist/dist/types/StorageArchivist.d.ts:37

### started

- started(notStartedAction?): boolean

- #### Parameters

  - ##### `Optional` notStartedAction: "error" | "throw" | "warn" | "log" | "none"

  #### Returns boolean

  Inherited from AbstractArchivist.started

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:37

### `Protected` stop

- stop(_timeout?): Promisable<StorageArchivist<TParams, TEventData>, never>

- #### Parameters

  - ##### `Optional` _timeout: number

  #### Returns Promisable<StorageArchivist<TParams, TEventData>, never>

  Inherited from AbstractArchivist.stop

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:114

### subscribe

- subscribe(_queryAccount?): void

- #### Parameters

  - ##### `Optional` _queryAccount: AccountInstance

  #### Returns void

  Inherited from AbstractArchivist.subscribe

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:38

### `Protected` validateConfig

- validateConfig(config?, parents?): boolean

- #### Parameters

  - ##### `Optional` config: unknown

  - ##### `Optional` parents: string[]

  #### Returns boolean

  Inherited from AbstractArchivist.validateConfig

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:115

### `Protected` writeToParent

- writeToParent(parent, payloads): Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

- #### Parameters

  - ##### parent: ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

  Inherited from AbstractArchivist.writeToParent

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:29

### `Protected` writeToParents

- writeToParents(payloads): Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

- #### Parameters

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promise<(SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  })[]>

  Inherited from AbstractArchivist.writeToParents

  - Defined in modules/packages/archivist/packages/abstract/dist/types/AbstractArchivist.d.ts:32

### `Static` create

- create<TModule>(this, params?): Promise<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns Promise<TModule>

  Inherited from AbstractArchivist.create

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:30

### `Static` factory

- factory<TModule>(this, params?): CreatableModuleFactory<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns CreatableModuleFactory<TModule>

  Inherited from AbstractArchivist.factory

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:31

Generated using TypeDoc